theory Boolean_algebra imports Complete_Lattices
begin


context complete_boolean_algebra
begin
  (* from: compl_eq_compl_iff *)

lemma compl_le_impl:
  assumes xley: "(- x) \<le> (- y)" 
  shows "y \<le> x"
proof -
  have "y \<le> x \<squnion>  y" by simp
  also have "... = -( - x \<sqinter>  - y)" by simp
  also from xley have "( - x \<sqinter>  - y) = - x" by (simp add: le_iff_inf)
  finally show ?thesis by simp
qed


lemma compl_le_compl_iff [simp]:
  "- x \<le> - y \<longleftrightarrow> y \<le> x"
by (fastforce intro: compl_le_impl)


lemma sup_ge_compl_top: 
  assumes nxleqy: "- x \<le> y" shows "x \<squnion> y = \<top>"
proof -
  from nxleqy
  have "x \<squnion> y = (x \<squnion> - x) \<squnion> y" by (simp only: sup_assoc le_iff_sup)
  thus ?thesis by (simp add: sup_compl_top)
qed


lemma inf_ge_compl_bot: 
  assumes nxleqy: "x \<le> - y" shows "x \<sqinter> y = \<bottom>"
proof -
  from nxleqy
  have  "x \<sqinter> y = (x \<sqinter> - y) \<sqinter> y" by (simp only: le_iff_inf)
  thus ?thesis by (simp add: inf_assoc compl_inf_bot)
qed


lemma inf_ge_compl_bot_iff:
  "(x \<le> y)=((x \<sqinter> - y) \<le> \<bottom> )"
proof (rule iffI)
  assume "x \<le> y"
  hence "x \<sqinter> y=x" by (simp add: inf_absorb1)
  hence "\<dots>\<sqinter> (- y)=(x \<sqinter> y)\<sqinter> (- y)" by (simp)
  hence "x \<sqinter> - y =x \<sqinter> \<bottom>" by (simp add: inf_assoc inf_compl_bot) 
  hence  "x \<sqinter> - y =  \<bottom> " by (simp add: inf_bot_right)
  then  show "(x \<sqinter> - y) \<le> \<bottom>" by (simp)
next
  assume "(x \<sqinter> - y) \<le> \<bottom>"
  hence  "(x \<sqinter> - y)\<sqinter> \<bottom> =(x \<sqinter> - y)" by (simp only: inf_absorb1)
  hence "\<bottom> \<squnion> y=(x \<sqinter> - y) \<squnion> y" by (simp)
  hence "y=(x\<squnion> y)\<sqinter> (- y \<squnion> y)" by (simp add: sup_inf_distrib2)
  hence "y = (x \<squnion> y) " by  (simp add: sup_commute sup_compl_top)
  then show "x \<le> y" using le_iff_sup by (simp)
qed

lemma le_bot_eq:
  "x \<le> \<bottom> =(x = \<bottom> )"
proof  (rule iffI)
  assume "x \<le> \<bottom> "
  hence "(x \<sqinter> top) = \<bottom>"  by (simp only: inf_ge_compl_bot compl_top_eq )
  then show "x= \<bottom> " using inf_top_right by (simp)
next 
  assume "x = \<bottom>"
  then show "x \<le> \<bottom>"  by (simp)
qed

end                             (* context complete_boolean_algebra *)


end
