(* Secure strings, useful for code extraction
   (replace strings defined as lists of chars).
 *)

theory Sstring imports Main

begin

datatype sstring = Str "string"

primrec
  str_unpack :: "sstring \<Rightarrow> string" where
  "str_unpack (Str s) = s"

definition 
  sstr_concat :: "sstring \<Rightarrow> sstring \<Rightarrow> sstring" (infixr "^^" 65) where
  "s1 ^^ s2 == Str ((str_unpack s1) @ (str_unpack s2))"



end
